﻿'追加
Imports System.Data.SqlServerCe
Imports System.IO

'データベースユーティリティ
Module DBUtility

    'データベースのファイル名
    Private Const DATABASE_FILENAME As String = "idea.sdf"

    'データベースの接続文字列
    Private Const CONNECTION_STRING As String = "Data Source = 'idea.sdf'; LCID=1033; Password = strongpassword; Encrypt = TRUE;"

    'テーブル作成のSQL
    Private Const COMMANDTEXT_CREATE_TABLE_IDEA As String = "CREATE TABLE IDEA(" _
    + "IDEA_ID BIGINT PRIMARY KEY IDENTITY(1,1) NOT NULL," _
    + "LIMIT_TIME DATETIME NOT NULL," _
    + "IDEA_CONTENTS NVARCHAR(2000) NOT NULL)"


    'データベースの初期化
    Public Sub InitializeDB()

        'DBファイルが存在する場合は何もしない
        If File.Exists(DATABASE_FILENAME) Then
            Exit Sub
        End If


        'DBを作成する
        Using engine As SqlCeEngine = New SqlCeEngine(CONNECTION_STRING)
            engine.CreateDatabase()

            'コネクションを作成して開く
            Dim con As SqlCeConnection = GetConnection()
            con.Open()

            'テーブルを作成する
            Dim commnd As SqlCeCommand = New SqlCeCommand(COMMANDTEXT_CREATE_TABLE_IDEA, con)
            commnd.ExecuteNonQuery()

            'コネクションを閉じる
            con.Close()
        End Using
    End Sub


    'コネクションを作成する
    Function GetConnection() As SqlCeConnection
        Return New SqlCeConnection(CONNECTION_STRING)
    End Function

End Module
